
object Test {

  def negatePoint (p:Point):Point = 
    p.move(-2*p.xCoord(),-2*p.yCoord())

  def rotateAroundPoint (p:Point, angle:Double, center:Point):Point = 
    p.add(negatePoint(center)).rotate(angle).add(center)

  def moveTwice (r:Rect,dx:Double,dy:Double):Rect = 
    r.move(dx,dy).move(dy,dx)

  def colorComplement[A] (c:Colored[A]):Color = 
    c.color().complement()

  def makeComplement[A] (c:Colored[A]):A = 
    c.updateColor(c.color().complement())

  def main (argv:Array[String]):Unit = run()

  def run () = {
    val p1 : Point = Point.cartesian(1,1)
    val q1 : Point = Point.cartesian(1,2)
    println("Rotating Point = " + rotateAroundPoint(q1,math.Pi/2,p1))

    val p2 : Point = CPoint.cartesian(1,1,Color.blue())
    val q2 : CPoint = CPoint.cartesian(1,2,Color.red())
    println("Rotating CPoint = " + rotateAroundPoint(q2,math.Pi/2,p2))

    println("\nq2 = " + q2)
    println("Complementing q2 = " + makeComplement(q2))

    val p3:Point = Point.cartesian(20,30)
    val q3:Point = CPoint.cartesian(40,60,Color.red())
    val r1:Rect = Rect.create(p3,q3)
    println("\nMoving Rect = " + moveTwice(r1,50,100))
    
    val r2:CRect = CRect.create(p3,q3,Color.blue())
    println("Moving CRect = " + moveTwice(r2,50,100))

    println("\nr2 = " + r2)
    println("Complementing r2 = " + makeComplement(r2))
  }
}


